#include <conio.h>
#include <stdio.h>
#include <process.h>
#include <dos.h>
#include <fcntl.h>
#include <sys\types.h>
#include <time.h>
#include <sys\stat.h>
#include <io.h>
#include <string.h>
#include <malloc.h>
#include <memory.h>

/******************************************/
/* (C) Copyright IBM Corporation 1986	  */
/******************************************/

/************************************************************************/
/* This program is written to demonstrate and introduce 		*/
/* the advanced function Interface					*/
/*									*/
/* For use with the IBM C 1.00 compiler with /Ze option (any model).	*/
/*									*/
/* CALLAFI.OBJ must be provided at the LINK stage.			*/
/* This provides the assembler 'glue' which allows IBM 'C' to call      */
/* the Advanced Function Interface.					*/
/************************************************************************/

/* The following definition must appear 1st of far definitions	*/
char far buff4k[400];		/* The AF Interface Task dependent buffer */
				/* The address of this buffer must be	  */
				/* passed to the Interface via an HINIT   */


#include "ibmafi.h"     /* The macros and structure definitions */

static HOPEN_DATA open_data = { 3, 0, 0 };	     /* Hopen Data blk	*/
static HCLOSE_DATA close_data = { 2, 0 };	     /* Hclose Data blk */
static HINIT_DATA state_data = { 2, 0 };	     /* State Data ptr	*/

static HEAR_DATA earfill = { 1, 0 };	/* End area fill block		*/

			/* the definitions for the centre hexagon */
static HLINE_DATA(6) hexag_l = {24,   323,383,	417,220,  607,220,  701,383,
				      607,548,	417,548};
static HLINE_DATA(6) hexag_s = {24,   201,240,	260,139,  380,139,  439,240,
				      380,343,	260,343};

static HCHST_DATA(128) xystring;	/* Character string block	*/
static HSCS_DATA set_cs = { 4, 0 };	/* Set Character set block	*/
static HSCOL_DATA colour   = { 4,0 };	/* set colour block		*/

static HQMODE_DATA query_mode  = { 18 }; /* query modes block		*/


static char palette[18][4] = {	/* palette definition */
	    /*	    R	 B    G 			*/
		    0,	 0,   0, 0,	/* black   0	*/
		 0x24,0x24,0x24, 0,	/* gray    1	*/
		 0x94,0x94,0x94, 0,	/* white   2	*/
		 0xfc,0xfc,0xfc, 0,	/* l white 3	*/
		    0,0x70,0x70, 0,	/* cyan    4	*/
		    0,0xfc,0xfc, 0,	/* l cyan  5	*/
		 0x70,	 0,0x48, 0,	/* brown   6	*/
		 0xfc,0x24,0xfc, 0,	/* yellow  7	*/
		    0,0x70,   0, 0,	/* blue    8	*/
		    0,0xfc,   0, 0,	/* l blue  9	*/
		 0x70,	 0,   0, 0,	/* red	   a	*/
		 0xfc,0x24,0x24, 0,	/* l red   b	*/
		 0x70,0x70,   0, 0,	/* magenta c	*/
		 0xb0,0xfc,   0, 0,	/* l magenta d	*/
		    0,	 0,0x70, 0,	/* green   e	*/
		 0x24,0x24,0xfc, 0,	/* l green f	*/
		    0,	 0,   0, 0,	/* 2 spare to allow for shuffling */
		    0,	 0,   0, 0
				};

static HLDPAL_DATA tab = { 10, 0, 0, 0, 16, &palette[0][0] };
static HINT_DATA hint_data = { 4, 0x80000000L };  /* flyback wait */
static HSPAL_DATA svpal_data
		       = { sizeof(svpal_data) - 2 }; /* palette save area */

static char chstring[100],path[64];
static char fontfile[][15] = {"stan1220.fnt","stan0814.fnt"};

extern struct CharSetDef *ldfont(char *); /* load a font, return CSD addr */
extern void drawquad(int,int,int,int,int,int,int,int,int);

void main(argc,argv)
int argc;
char *argv[];
{
FILE *msgfile;	/* File containing user messages */
char far *stataddr = buff4k;	/* task dependent buffer address */
int inp_char;
long prev_time,time_now;	/* timer fields 		*/

  if (argc >= 2)	/* path is parameter to program, build path */
  {
    strcpy(path,argv[1]);
    strcat(path,"\\");
  }
  else
    strcpy(path,"");


 /* get afi block ptr */

  if (NULL == getafi()) 	/* check interface is installed 	*/
  {				/* if not print contents of NOAFI.MSG	*/
			 /* this technique allows language independence */

    strcpy(chstring,path);
    strcat(chstring,"noafi.msg");       /* build file name      */

    msgfile = fopen(chstring,"r");
    while (EOF != (inp_char = fgetc(msgfile))) printf("%c",inp_char);
    fclose(msgfile);
    exit(0);		/* exit from program	*/

  }
  HSPAL(&svpal_data);  /* save palette, as prog uses non standard */

  HOPEN(&open_data);	/* open Advanced Function Interface	*/
  if (open_data.iflags) /* if non zero return from HOPEN	*/

  {
    strcpy(chstring,path);
    strcat(chstring,"nohopen.msg");       /* build file name      */

    msgfile = fopen(chstring,"r");
    while (EOF != (inp_char = fgetc(msgfile))) printf("%c",inp_char);
    fclose(msgfile);
    printf("'%X'\n",open_data.iflags);
    exit(0);		/* exit from program	*/

  }

  state_data.segment = FP_SEG(stataddr);	/* addr of Task Dep. buffer */
  HINIT(&state_data);			/* to Interface 		*/

  HLDPAL(&tab); 	/* load initial palette */

  HQMODE(&query_mode);	/* Query default mode (may be 0 or 1)	*/

  strcpy(chstring,path);      /* build filename of appropriate font for mode */
  strcat(chstring,fontfile[(1 == query_mode.mode) ? 1 : 0]);

  set_cs.address = ldfont(chstring);	   /* load font for alphanumerics */

  if (1 == query_mode.mode)	/* if 640 * 480 mode (1) */
  {		/* draw outside shapes */
    drawquad(4,    98,141,107,127,232,343,214,343);	/* cyan 	*/
    drawquad(5,   110,121,118,106,255,343,237,343);	/* light cyan	*/
    drawquad(6,   178,200,295,0,  312,0  ,187,216);	/* brown	*/
    drawquad(7,   190,221,318,0,  335,0  ,199,236);	/* yellow	*/
    drawquad(8,   284, 96,514, 96,523,112,275,112);	/* blue 	*/
    drawquad(9,   273,117,526,117,535,133,263,133);	/* light blue	*/
    drawquad(0x0a,408,139,426,139,542,337,533,353);	/* red		*/
    drawquad(0x0b,385,139,403,139,530,358,521,373);	/* light red	*/
    drawquad(0x0c,454,266,463,282,348,479,330,479);	/* magenta	*/
    drawquad(0x0d,442,246,451,261,325,479,307,479);	/* light magenta*/
    drawquad(0x0e,116,367,366,367,357,382,124,382);	/* green	*/
    drawquad(0x0f,104,348,376,348,369,362,113,362);	/* light green	*/
  }
  else
  {		/* if 1024 * 768 mode (0)	*/
    drawquad(4,   159,228,172,205,371,548,344,548);	/* cyan 	*/
    drawquad(5,   177,196,191,172,409,548,381,548);	/* light cyan	*/
    drawquad(6,   286,320,469,0,  497,0  ,300,343);	/* brown	*/
    drawquad(7,   304,351,506,0,  535,0  ,319,375);	/* yellow	*/
    drawquad(8,   454,156,824,156,837,180,439,180);	/* blue 	*/
    drawquad(9,   434,188,842,188,856,212,421,212);	/* light blue	*/
    drawquad(0x0a,654,220,681,220,865,540,851,565);	/* red		*/
    drawquad(0x0b,617,220,644,220,846,573,832,597);	/* light red	*/
    drawquad(0x0c,723,424,738,448,551,767,527,767);	/* magenta	*/
    drawquad(0x0d,705,392,719,416,516,767,488,767);	/* light magenta*/
    drawquad(0x0e,188,588,583,588,569,612,202,612);	/* green	*/
    drawquad(0x0f,169,556,602,556,588,580,183,580);	/* light green	*/
  }

  colour.index = 2; /* dim white  on this palette */
  HSCOL(&colour);	/* set hexagon colour */

  HBAR();	/* begin area */
  if (1 == query_mode.mode)	/* draw appropriate hexagon for mode */
    HLINE(&hexag_s);
  else
    HLINE(&hexag_l);
  HEAR(&earfill);	/* end area	*/

  if (NULL != set_cs.address)	/* if the font was loaded OK */
  {
    HSCS(&set_cs);	/* set character set */

    colour.index =  3;	/* bright white on this palette */
    HSCOL(&colour);	/* set colour			*/

				/* set upper left of whole hexagon area */
    xystring.coord.x_coord = ((1 == query_mode.mode) ? 201 : 323);
    xystring.coord.y_coord = ((1 == query_mode.mode) ? 139 : 220);

    strcpy(chstring,path);		/* build filename of intro msg file */
    strcat(chstring,"afiintro.msg");

    msgfile = fopen(chstring,"r");      /* open message file */
    while (NULL != fgets(xystring.string,128,msgfile))	/* output every line */

    {
      xystring.length = sizeof(coord_pr) +  /* calc length of this line */
				   strlen(xystring.string) - 1;
      xystring.coord.y_coord +=      /* update y posn for each line */
			set_cs.address->cellheight;
      HCHST(&xystring); 	/* draw string	*/

      printf("%s\n",xystring.string); /* also on VGA in case of hardware prob */

    }

    fclose(msgfile);

  }

/************************************************************************/
/*  While waiting for ENTER, rotate the symbol by pallete update	*/
/* once every second							*/
/************************************************************************/

  while ((!kbhit()) || (0x0d != getch()))	/* wait for ENTER */
  {
    /* shuffle palette entries to rotate symbol */
    memcpy(palette[ 6],palette[ 4],48);
    memcpy(palette[ 4],palette[16],8);


    HINT(&hint_data);		/* wait for frame flyback */
    HLDPAL(&tab);		/* load updated palette */

    while (prev_time == time(&time_now));	/* wait till time changes */
    prev_time = time_now;	/* save for next delay */
  }

  HCLOSE(&close_data);	/* close AF Interface	*/

  HRPAL(&svpal_data);	/* restore original palette */

} /* end of main */

/***************************************************************************/


struct CharSetDef *ldfont(fname)   /* load a font, and return CSD address */
char *fname;			   /* filename of font file		*/
{
word fontlen;		/* size of font to load 	*/
struct FontFileDefn *ioaddr;	/* address to load it	*/
int f_id;			/* file id		*/
struct CharSetDef *a_csd;	/* address of Character Set Definition blk */


  f_id=open(fname,O_RDONLY|O_BINARY);	/*  open font file	*/
  if (f_id==-1) 	     /* return NULL if cannot be loaded */
    return(NULL);

  fontlen = (word) lseek(f_id,0L,2);	 /* get length of font data	*/
  ioaddr = (struct FontFileDefn *) malloc(fontlen);   /* allocate space */
  if (NULL == ioaddr) return(NULL);	/* if not enough space		*/
  lseek(f_id,0L,0);			/* back to start of file	*/
  read(f_id,(char *) ioaddr,fontlen);	/* read into allocated space	*/

  a_csd = (struct CharSetDef *) (((char *) ioaddr) +  /* set CSD addr	*/
	    ioaddr->page_array[ioaddr->def_page].csd_offset);

		/* update all address field with load address */
  a_csd->chardef1 = ((byte far *) ioaddr) + ((long) a_csd->chardef1);
  a_csd->chardef2 = ((byte far *) ioaddr) + ((long) a_csd->chardef2);
  a_csd->chardef3 = ((byte far *) ioaddr) + ((long) a_csd->chardef3);
  a_csd->indextbl = (word far *)
		  (((byte far *) ioaddr) + ((long) a_csd->indextbl));
  a_csd->enveltbl = ((byte far *) ioaddr) + ((long) a_csd->enveltbl);


  close(f_id);		/* close font file */


  return(a_csd);	/* return address of Char Set Defn block	*/
}


void drawquad(col,x0,y0,x1,y1,x2,y2,x3,y3)	/* draw a quadrilateral */
int col;			/* colour	*/
int x0,y0,x1,y1,x2,y2,x3,y3;	/* coords	*/
{
static HLINE_DATA(4) quad = {16,   0,0, 0,0, 0,0, 0,0};

  quad.coords[0].x_coord = x0;	 /* fill in coords	*/
  quad.coords[0].y_coord = y0;

  quad.coords[1].x_coord = x1;
  quad.coords[1].y_coord = y1;

  quad.coords[2].x_coord = x2;
  quad.coords[2].y_coord = y2;

  quad.coords[3].x_coord = x3;
  quad.coords[3].y_coord = y3;

  colour.index = (long) col;
  HSCOL(&colour);	/* set supplied colour		*/

  HBAR();		/* begin area			*/
  HLINE(&quad); 	/* draw quadrilateral		*/
  HEAR(&earfill);	/* end area			*/

}

